/*
*	SmallBASIC, library API
*
*	Nicholas Christopoulos
*/

#if !defined(_sb_proc_h)
#define _sb_proc_h

#if !defined(PI)
#define	PI	3.14159265358979323846
#endif

#include "sys.h"
#include "str.h"
#include "kw.h"
#include "panic.h"
#include "var.h"
#include "device.h"
#include "blib.h"

#if defined(__cplusplus)
extern "C" {
#endif

/* */
#if !defined(BRUN_MODULE)
extern int prog_error;
extern word prog_length;
extern byte *prog_source;
extern word prog_ip;
extern word prog_line;
extern var_t **tvar;
extern lab_t *tlab;
extern word	data_ip;			// READ/DATA position
#endif

void	bc_loop(int isf);
void	eval(var_t *result) 		;
word	getarrayidx(var_t *array) 	;

void	print_var(var_t *var)		SEC(TRASH);

#if defined(_PalmOS)
void	err_syntax(void)			SEC(TRASH);
void	err_syntaxsep(int c)		SEC(TRASH);
#else
#define	err_syntax() 				rt_raise("%s (%d): SYNTAX ERROR!\n", __FILE__, __LINE__)
#define	err_syntaxsep(c)			rt_raise("%s (%d): SYNTAX ERROR, MISSING SEPARATOR '%c'\n", __FILE__, __LINE__, (c))
#endif
void	err_typemismatch(void)		SEC(TRASH);
void	err_stackmess()				SEC(TRASH);
void	err_parm_num()				SEC(TRASH);
void	err_parm_byref(int n)		SEC(TRASH);

void	par_getvar(var_t *var)		;
void	par_getstr(var_t *var)		;
long	par_getint(void)			;
double	par_getnum(void)   			;
int		par_getsep(void)   			;
void	par_getcomma(void)     		;
void	par_getsharp(void)     		;
void	par_getsemicolon(void)		;

void	set_dataip(word label_id);

#if defined(__cplusplus)
}
#endif

#endif

